<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

declare(strict_types = 1);

namespace Kufer\Web\Classes\Dbfilter\RegisteredCall;

use Kufer\Web\Classes\Dbfilter\AbstractSQLFilter;
use Kufer\Web\Classes\Dbfilter\SQLFilterUtils;
use Kufer\Web\Classes\Identifier\Identifier;

class RegisteredDBCallIdentifierNoGuid extends RegisteredDBCall
{
  public function getType(): int
  {
    return \Kufer\Web\Classes\Dbfilter\AbstractSQLFilter::TYPE_IDENTIFIER;
  }

  public function getCapabilities(): int
  {
    return static::SUPPORTS_EQUALS
      | static::SUPPORTS_EQUALS_DEFAULT;
  }

  private function normalize($value): Identifier
  {
    return \Kufer\Web\Classes\Identifier\IdentifierFactory::createFromIdIfNecessary($value);
  }

  
  private function normalizeIterable(iterable $value): array
  {
    return (new \Kufer\Web\Classes\Stream\IterableStream($value))
      ->map(array($this, 'normalize'))
      ->toArray();
  }

  public function like(AbstractSQLFilter $filter, $value): callable
  {
    throw new CallNotSupportedException('Abfrage like hier nicht unterstützt.');
  }

  public function contains(AbstractSQLFilter $filter, $value): callable
  {
    throw new CallNotSupportedException('Abfrage contains hier nicht unterstützt.');
  }

  public function equals(AbstractSQLFilter $filter, $value): callable
  {
    return SQLFilterUtils::filterEqualsInt($this->table, $this->column, $this->normalize($value)->getId());
  }

  public function equalsDefault(AbstractSQLFilter $filter, $value, $default): callable
  {
    throw new CallNotSupportedException('Abfrage less hier nicht unterstützt.');
  }

  public function in(AbstractSQLFilter $filter, iterable $value): callable
  {
    return SQLFilterUtils::filterInIntDefault($this->table, $this->column, array_map(static function(Identifier $id) {
      return $id->getId();
    }, $this->normalizeIterable($value)), 0);
  }

  public function inDefault(AbstractSQLFilter $filter, iterable $value, $default): callable
  {
    throw new CallNotSupportedException('Abfrage less hier nicht unterstützt.');
  }

  public function less(AbstractSQLFilter $filter, $value): callable
  {
    throw new CallNotSupportedException('Abfrage less hier nicht unterstützt.');
  }

  public function lessDefault(AbstractSQLFilter $filter, $value, $default): callable
  {
    throw new CallNotSupportedException('Abfrage lessDefault hier nicht unterstützt.');
  }

  public function greater(AbstractSQLFilter $filter, $value): callable
  {
    throw new CallNotSupportedException('Abfrage greater hier nicht unterstützt.');
  }

  public function greaterDefault(AbstractSQLFilter $filter, $value, $default): callable
  {
    throw new CallNotSupportedException('Abfrage greaterDefault hier nicht unterstützt.');
  }

  public function is(AbstractSQLFilter $filter): callable
  {
    throw new CallNotSupportedException('Abfrage is hier nicht unterstützt.');
  }

  public function isDefault(AbstractSQLFilter $filter, $default): callable
  {
    throw new CallNotSupportedException('Abfrage is hier nicht unterstützt.');
  }
}